include:
  - project: 'eclipsefdn/it/releng/gitlab-runner-service/gitlab-ci-templates'
    file: '/jobs/buildkit.gitlab-ci.yml'

variables:
  SPRING_PROFILES_ACTIVE: gitlab-ci

stages:
  - test-and-compile
  - docker-build
  - deploy

maven-build:
  image: maven:3-jdk-11
  stage: test-and-compile
  script: mvn clean install
  artifacts:
    paths:
      - target/*.jar
      - target/surefire-reports/*.xml
    reports:
      junit: target/surefire-reports/TEST-*.xml

docker-build:
  extends: .buildkit
  stage: docker-build
  variables:
    CI_REGISTRY: ${HARBOR_HOST}
    CI_REGISTRY_USER: ${HARBOR_USERNAME}
    CI_REGISTRY_PASSWORD: ${HARBOR_PASSWORD}
    CI_REGISTRY_IMAGE: ${HARBOR_HOST}/${HARBOR_PROJECT}/${CI_PROJECT_NAME}
    DOCKERFILE_NAME: Dockerfile


deploy:
  stage: deploy
  image: alpine:3.16
  dependencies:
    - docker-build
  before_script:
    - apk add --no-cache git wget bash
    - apk add yq --repository=https://dl-cdn.alpinelinux.org/alpine/edge/community
    - git config --global --add safe.directory /builds/xfsc/self-description-tooling/sd-creation-wizard/sd-creation-wizard-api
    - git remote set-url origin https://${CI_USERNAME}:${CI_PUSH_TOKEN}@gitlab.eclipse.org/eclipse/xfsc/self-description-tooling/sd-creation-wizard-api.git
    - git config --global user.email "gitlab@gitlab.com"
    - git config --global user.name "GitLab CI/CD"
  script:
    - git checkout -B main
    - cd manifests
    - echo $CI_COMMIT_SHORT_SHA
    - yq eval -i ".deployments.default.containers[0].tag = \"$CI_COMMIT_SHORT_SHA"\" values.yaml
    - git commit -am '[skip ci] DEV image update'    
    - git push origin main
  only:
    - main
